"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generatePreviewLink = exports.getPostPreview = exports.getSitePreview = void 0;

var _services = require("../services");

const getSitePreview = async (_ref, dispatch, config) => {
  let {
    siteID,
    previewID
  } = _ref;
  const result = await _services.previewServices.getSitePreview({
    siteID,
    previewID
  }, dispatch, config);

  if (result) {
    dispatch({
      type: "ADD_SITE",
      payload: result
    });
  }

  return result;
};

exports.getSitePreview = getSitePreview;

const getPostPreview = async (_ref2, dispatch, config) => {
  let {
    siteID,
    previewID
  } = _ref2;
  const result = await _services.previewServices.getPostPreview({
    siteID,
    previewID
  }, dispatch, config);

  if (result) {
    dispatch({
      type: "ADD_EDITOR_POST",
      payload: result
    });
  }

  return result;
};

exports.getPostPreview = getPostPreview;

const generatePreviewLink = async (_ref3, dispatch, config) => {
  let {
    siteID,
    postID,
    expiryDate
  } = _ref3;
  const result = await _services.previewServices.generatePreviewLink({
    siteID,
    postID,
    expiryDate
  }, dispatch, config);
  return result;
};

exports.generatePreviewLink = generatePreviewLink;