"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getUnpublishedChanges = exports.syncFields = exports.deploySite = exports.getSite = exports.getSites = exports.deleteSite = exports.updateSite = exports.addSite = void 0;

var _router = require("@reach/router");

var _services = require("../services");

var _routes = _interopRequireDefault(require("../routes"));

const addSite = async (_ref, dispatch, config) => {
  let {
    title,
    ownerID
  } = _ref;
  const result = await _services.siteServices.addSite({
    title,
    ownerID
  }, dispatch, config);

  if (result) {
    dispatch({
      type: 'ADD_SITE',
      payload: result
    });
    (0, _router.navigate)((0, _routes.default)('dashboard', {
      siteID: result.id
    }));
  }

  return result;
};

exports.addSite = addSite;

const updateSite = async (args, dispatch, config) => {
  const result = await _services.siteServices.updateSite(args, dispatch, config);

  if (result) {
    dispatch({
      type: 'ADD_SITE',
      payload: result
    });
    dispatch({
      type: 'ADD_EDITOR_SITE',
      payload: result
    });
  }

  return result;
};

exports.updateSite = updateSite;

const deleteSite = async (_ref2, dispatch, config) => {
  let {
    id
  } = _ref2;
  const result = await _services.siteServices.deleteSite({
    id
  }, dispatch, config);

  if (result) {
    dispatch({
      type: "DELETE_SITE",
      payload: result
    });
  }

  return result;
};

exports.deleteSite = deleteSite;

const getSites = async (args, dispatch, config) => {
  const result = await _services.siteServices.getSites(args, dispatch, config);

  if (result) {
    dispatch({
      type: 'ADD_SITES',
      payload: result
    });
  }

  return result;
};

exports.getSites = getSites;

const getSite = async (_ref3, dispatch, config) => {
  let {
    siteID
  } = _ref3;
  const result = await _services.siteServices.getSite({
    siteID
  }, dispatch, config);
  return result;
};

exports.getSite = getSite;

const deploySite = async (_ref4, dispatch, config) => {
  let {
    id
  } = _ref4;
  const result = await _services.siteServices.deploySite({
    id
  }, dispatch, config);

  if (result) {
    dispatch({
      type: 'ADD_SITE',
      payload: result
    });
  }

  return result;
};

exports.deploySite = deploySite;

const syncFields = async (_ref5, dispatch, config) => {
  let {
    fields,
    apiKey
  } = _ref5;
  const result = await _services.siteServices.syncFields({
    fields,
    apiKey
  }, dispatch, config);

  if (result) {
    dispatch({
      type: 'ADD_SITE',
      payload: result
    });
  }

  return result;
};

exports.syncFields = syncFields;

const getUnpublishedChanges = async (_ref6, dispatch, config) => {
  let {
    siteID
  } = _ref6;
  const result = await _services.siteServices.getUnpublishedChanges({
    siteID
  }, dispatch, config);
  return result;
};

exports.getUnpublishedChanges = getUnpublishedChanges;