"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteUser = exports.updateUser = exports.getUsers = exports.getUser = exports.getAuthUser = exports.addUser = void 0;

var _services = require("../services");

var _actions = require("../actions");

const addUser = async (_ref, dispatch, config) => {
  let {
    siteID,
    email,
    role
  } = _ref;
  const result = await _services.userServices.addUser({
    siteID,
    email,
    role
  }, dispatch, config);
  return result;
};

exports.addUser = addUser;

const getAuthUser = async (_ref2, dispatch, config) => {
  let {} = _ref2;
  const result = await _services.userServices.getAuthUser({}, dispatch, config);

  if (result) {
    if (result.hasOwnProperty('success') && !result.success) {
      _actions.authActions.signOut({}, dispatch, config);
    } else {
      dispatch({
        type: "ADD_AUTH_USER",
        payload: result
      });
    }
  }

  return result;
};

exports.getAuthUser = getAuthUser;

const getUser = async (_ref3, dispatch, config) => {
  let {
    siteID,
    id
  } = _ref3;
  const result = await _services.userServices.getUser({
    siteID,
    id
  }, dispatch, config);
  return result;
};

exports.getUser = getUser;

const getUsers = async (_ref4, dispatch, config) => {
  let {
    siteID,
    page,
    limit
  } = _ref4;
  const result = await _services.userServices.getUsers({
    siteID,
    page,
    limit
  }, dispatch, config);
  return result;
};

exports.getUsers = getUsers;

const updateUser = async (_ref5, dispatch, config) => {
  let {
    siteID,
    id,
    role
  } = _ref5;
  const result = await _services.userServices.updateUser({
    siteID,
    id,
    role
  }, dispatch, config);
  return result;
};

exports.updateUser = updateUser;

const deleteUser = async (_ref6, dispatch, config) => {
  let {
    siteID,
    id
  } = _ref6;
  const result = await _services.userServices.deleteUser({
    siteID,
    id
  }, dispatch, config);
  return result;
};

exports.deleteUser = deleteUser;