"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _router = require("@reach/router");

var _DeploymentBadge = _interopRequireDefault(require("./DeploymentBadge"));

var _AvatarMenu = _interopRequireDefault(require("./AvatarMenu"));

var _store = require("../store");

var _routes = _interopRequireDefault(require("../routes"));

var _templateObject, _templateObject2, _templateObject3;

const messages = {
  'undeployed-changes': {
    onClick: () => (0, _router.navigate)((0, _routes.default)('dashboard')),
    title: 'Unpublished changes',
    description: 'Click the deployment button to publish the latest updates.'
  },
  'missing-front-page': {
    onClick: () => (0, _router.navigate)((0, _routes.default)('collection', {
      postTypeID: 'page'
    })),
    title: 'Homepage missing',
    description: 'Assign the homepage attribute within the page settings to any page.'
  },
  'unpublished-front-page': {
    onClick: () => (0, _router.navigate)((0, _routes.default)('collection', {
      postTypeID: 'page'
    })),
    title: 'Homepage not published',
    description: "The homepage status is set to draft or trash and therefore won't get included in the build."
  }
};

const CmsHeader = props => {
  var _sites$siteID, _sites$siteID2, _sites$siteID3, _sites$siteID4, _sites$siteID4$postTy, _sites$siteID4$postTy2, _sites$siteID4$postTy3, _sites$siteID4$postTy4, _sites$siteID5, _sites$siteID6, _sites$siteID6$errors;

  const {
    title
  } = props;
  const [{
    cmsState: {
      siteID,
      sites
    }
  }] = (0, _store.useStore)();
  const deployment = sites === null || sites === void 0 ? void 0 : (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : _sites$siteID.deployment;
  const notifications = []; // We're only pushing keys to the notifications array to improve useMemo performance

  if (deployment !== null && deployment !== void 0 && deployment.undeployedChanges) {
    notifications.push('undeployed-changes');
  }

  if (!(sites !== null && sites !== void 0 && (_sites$siteID2 = sites[siteID]) !== null && _sites$siteID2 !== void 0 && _sites$siteID2.frontPage)) {
    notifications.push('missing-front-page');
  }

  if (sites !== null && sites !== void 0 && (_sites$siteID3 = sites[siteID]) !== null && _sites$siteID3 !== void 0 && _sites$siteID3.frontPage && (sites === null || sites === void 0 ? void 0 : (_sites$siteID4 = sites[siteID]) === null || _sites$siteID4 === void 0 ? void 0 : (_sites$siteID4$postTy = _sites$siteID4.postTypes) === null || _sites$siteID4$postTy === void 0 ? void 0 : (_sites$siteID4$postTy2 = _sites$siteID4$postTy['page']) === null || _sites$siteID4$postTy2 === void 0 ? void 0 : (_sites$siteID4$postTy3 = _sites$siteID4$postTy2.posts) === null || _sites$siteID4$postTy3 === void 0 ? void 0 : (_sites$siteID4$postTy4 = _sites$siteID4$postTy3[sites === null || sites === void 0 ? void 0 : (_sites$siteID5 = sites[siteID]) === null || _sites$siteID5 === void 0 ? void 0 : _sites$siteID5.frontPage]) === null || _sites$siteID4$postTy4 === void 0 ? void 0 : _sites$siteID4$postTy4.status) !== 'publish') {
    notifications.push('unpublished-front-page');
  } // Add CMS errors


  if (sites !== null && sites !== void 0 && (_sites$siteID6 = sites[siteID]) !== null && _sites$siteID6 !== void 0 && (_sites$siteID6$errors = _sites$siteID6.errors) !== null && _sites$siteID6$errors !== void 0 && _sites$siteID6$errors.length) {
    sites[siteID].errors.map(o => notifications.push(o.id));
  }

  return (0, _react.useMemo)(() => {
    const buttons = [];
    buttons.push( /*#__PURE__*/_react.default.createElement(_DeploymentBadge.default, {
      key: "deployment-badge",
      deployment: deployment
    }));

    const notificationsContent = /*#__PURE__*/_react.default.createElement(Notifications, null, /*#__PURE__*/_react.default.createElement(_antd.List, {
      itemLayout: "horizontal",
      dataSource: notifications,
      renderItem: key => {
        var _sites$siteID7;

        const item = messages[key] || (sites === null || sites === void 0 ? void 0 : (_sites$siteID7 = sites[siteID]) === null || _sites$siteID7 === void 0 ? void 0 : _sites$siteID7.errors.find(o => o.id === key));
        return /*#__PURE__*/_react.default.createElement(_antd.List.Item, {
          key: key,
          onClick: item.onClick
        }, /*#__PURE__*/_react.default.createElement(_antd.List.Item.Meta, {
          title: item.title,
          description: item.description
        }));
      }
    }));

    buttons.push( /*#__PURE__*/_react.default.createElement(_antd.Popover, {
      key: 'notifications',
      title: "Notifications",
      content: notificationsContent,
      arrow: true,
      trigger: ['click'],
      placement: "bottomRight"
    }, /*#__PURE__*/_react.default.createElement(_antd.Badge, {
      size: "small",
      count: notifications.length
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      icon: /*#__PURE__*/_react.default.createElement(_icons.BellOutlined, null),
      type: "default"
    }))));
    buttons.push( /*#__PURE__*/_react.default.createElement(_AvatarMenu.default, {
      key: "avatar-menu"
    }));
    buttons.push( /*#__PURE__*/_react.default.createElement(_router.Link, {
      key: "view-website",
      to: "/"
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      children: "View Website"
    })));
    return /*#__PURE__*/_react.default.createElement(Container, null, /*#__PURE__*/_react.default.createElement(Content, null, /*#__PURE__*/_react.default.createElement(_antd.PageHeader, {
      title: title,
      extra: buttons
    })));
  }, [deployment, notifications]);
};

const Container = _styledComponents.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  position: fixed;\n  z-index: 10;\n  top: 0;\n  right: 0;\n  width: calc(100% - 250px);\n  height: 50px;\n  background: #fff;\n  border-bottom: 1px solid #d9e1ef;\n"])));

const Content = _styledComponents.default.div(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n  max-width: 1024px;\n  padding: 0 40px;\n  margin: 0 auto;\n"])));

const Notifications = _styledComponents.default.div(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n  width: 320px;\n"])));

var _default = CmsHeader;
exports.default = _default;