"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _Input = _interopRequireDefault(require("./Input"));

var _PostTreeSelect = _interopRequireDefault(require("./PostTreeSelect"));

var _utils = require("../utils");

var _store = require("../store");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const LinkSelector = props => {
  var _sites$siteID;

  const {
    value = {},
    placeholder,
    onChange,
    removable
  } = props;
  const [{
    config,
    cmsState: {
      sites,
      siteID
    }
  }, dispatch] = (0, _store.useStore)();
  const [post, setPost] = (0, _react.useState)('');
  const [link, setLink] = (0, _react.useState)(value);
  (0, _react.useEffect)(() => {
    // Clear post on load
    setPost('');
  }, []);
  const allPosts = [];
  Object.values((_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : _sites$siteID.postTypes).map(o => {
    Object.values(o.posts).map(p => p.status === 'publish' && allPosts.push(_objectSpread(_objectSpread({}, p), {}, {
      caption: o.title
    })));
  });

  const handleChange = (name, newValue) => {
    setLink(_objectSpread(_objectSpread({}, link), {}, {
      [name]: newValue
    }));
  };

  const handleSubmit = () => {
    onChange(link);
    setLink({
      title: '',
      url: '',
      target: ''
    });
    dispatch({
      type: "CLOSE_DIALOG"
    });
  };

  const handleRemove = () => {
    onChange({
      title: link.title,
      url: '',
      target: ''
    });
    setLink({
      title: '',
      url: '',
      target: ''
    });
    dispatch({
      type: "CLOSE_DIALOG"
    });
  };

  const handleTreeSelect = id => {
    setPost(id);

    if (id) {
      var _sites$siteID2, _sites$siteID3;

      const post = allPosts.find(o => o.id === id);
      const postType = Object.values((_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : _sites$siteID2.postTypes).find(o => o.id === post.postTypeID);
      setLink({
        title: link.title || post.title,
        url: (0, _utils.generateSlug)(postType, post.id, (_sites$siteID3 = sites[siteID]) === null || _sites$siteID3 === void 0 ? void 0 : _sites$siteID3.frontPage, true),
        target: false
      });
    }
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_PostTreeSelect.default, {
    label: "Select Post",
    items: allPosts,
    value: post,
    onChange: handleTreeSelect
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Link",
    value: (link === null || link === void 0 ? void 0 : link.url) || '',
    placeholder: 'https://',
    onChange: e => handleChange('url', e.target.value)
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Text",
    value: (link === null || link === void 0 ? void 0 : link.title) || '',
    placeholder: placeholder || 'Text',
    onChange: e => handleChange('title', e.target.value)
  }), /*#__PURE__*/_react.default.createElement(_antd.Checkbox, {
    value: '_blank',
    checked: (link === null || link === void 0 ? void 0 : link.target) === '_blank',
    onChange: e => handleChange('target', e.target.checked ? '_blank' : ''),
    children: "Open in new tab"
  }), /*#__PURE__*/_react.default.createElement(_antd.Space, null, removable && /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: 'Remove',
    onClick: handleRemove,
    danger: true
  }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: 'Update',
    onClick: handleSubmit,
    type: "primary",
    disabled: !link.url || !link.title
  }))));
};

var _default = LinkSelector;
exports.default = _default;