"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _router = require("@reach/router");

var _antd = require("antd");

var _Home = _interopRequireDefault(require("../pages/Home"));

var _Profile = _interopRequireDefault(require("../pages/Profile"));

var _PostEditor = _interopRequireDefault(require("../pages/PostEditor"));

var _Dashboard = _interopRequireDefault(require("../pages/Dashboard"));

var _Media = _interopRequireDefault(require("../pages/Media"));

var _PostType = _interopRequireDefault(require("../pages/PostType"));

var _GeneralSettings = _interopRequireDefault(require("../pages/GeneralSettings"));

var _Taxonomy = _interopRequireDefault(require("../pages/Taxonomy"));

var _Users = _interopRequireDefault(require("../pages/Users"));

var _Loader = _interopRequireDefault(require("./Loader"));

var _PrivateRoute = _interopRequireDefault(require("./PrivateRoute"));

var _theme = require("../theme");

var _store = require("../store");

var _actions = require("../actions");

var _auth = require("../utils/auth");

var _routes = require("../routes");

// import components
const Master = props => {
  var _authUser$capabilitie, _authUser$capabilitie2;

  const {
    defaultComponent
  } = props;
  const [{
    config,
    authState: {
      authUser
    },
    appState: {
      dialog
    },
    cmsState: {
      sites,
      siteID
    },
    editorState: {
      siteHasChanged
    }
  }, dispatch] = (0, _store.useStore)();
  const previewID = (0, _auth.isPreview)(); // timer for refresh token and site updates

  const [timer, setTimer] = (0, _react.useState)(0);
  (0, _react.useEffect)(() => {
    const intervalID = setInterval(() => {
      !previewID && setTimer(time => time + 1);
    }, 10000); // 10 seconds
    // Clear both timers

    return () => {
      clearInterval(intervalID);
    };
  }, []);
  (0, _react.useEffect)(() => {
    const loadUser = async () => {
      await _actions.userActions.getAuthUser({}, dispatch, config);
    };

    !previewID && loadUser();
  }, []);
  (0, _react.useEffect)(() => {
    const refreshContent = async () => {
      // Refresh token after 1 minute (6 * 10 seconds)
      if (timer > 0 && timer % 6 === 0) {
        await _actions.authActions.refreshToken({}, dispatch, config);
      }

      if (previewID) {
        await _actions.previewActions.getSitePreview({
          siteID: config.siteID,
          previewID
        }, dispatch, config);
      } else {
        const result = await _actions.siteActions.getSite({
          siteID: config.siteID
        }, dispatch, config);

        if (result) {
          dispatch({
            type: 'ADD_SITE',
            payload: result
          });

          if (!siteHasChanged) {
            // Silently update site in editor if there are no changes
            dispatch({
              type: 'ADD_EDITOR_SITE',
              payload: result
            });
          }
        }
      }
    };

    refreshContent();
  }, [timer]);

  if (!sites[siteID]) {
    return /*#__PURE__*/_react.default.createElement(_Loader.default, null);
  }

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_theme.CmsStyles, null), /*#__PURE__*/_react.default.createElement(_router.Router, null, /*#__PURE__*/_react.default.createElement(_PrivateRoute.default, {
    path: "".concat(_routes.ROUTE_APP),
    component: _Home.default
  }), /*#__PURE__*/_react.default.createElement(_PrivateRoute.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_PROFILE),
    component: _Profile.default
  }), /*#__PURE__*/_react.default.createElement(_PrivateRoute.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID"),
    component: _Dashboard.default
  }), /*#__PURE__*/_react.default.createElement(_PrivateRoute.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_MEDIA),
    component: _Media.default
  }), /*#__PURE__*/_react.default.createElement(_PrivateRoute.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_POST_TYPE, "/:postTypeID"),
    component: _PostType.default
  }), /*#__PURE__*/_react.default.createElement(_PrivateRoute.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_TAXONOMY, "/:taxonomyID"),
    component: _Taxonomy.default
  }), (authUser === null || authUser === void 0 ? void 0 : (_authUser$capabilitie = authUser.capabilities) === null || _authUser$capabilitie === void 0 ? void 0 : _authUser$capabilitie.manage_options) && /*#__PURE__*/_react.default.createElement(_PrivateRoute.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_SETTINGS_GENERAL),
    component: _GeneralSettings.default
  }), (authUser === null || authUser === void 0 ? void 0 : (_authUser$capabilitie2 = authUser.capabilities) === null || _authUser$capabilitie2 === void 0 ? void 0 : _authUser$capabilitie2.list_users) && /*#__PURE__*/_react.default.createElement(_PrivateRoute.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_USERS),
    component: _Users.default
  }), /*#__PURE__*/_react.default.createElement(_PrivateRoute.default, {
    path: '*',
    component: _PostEditor.default,
    defaultComponent: defaultComponent
  })), dialog.open && /*#__PURE__*/_react.default.createElement(_antd.Modal, {
    transitionName: "none",
    maskTransitionName: "none",
    title: dialog.title,
    visible: true,
    onCancel: () => dispatch({
      type: 'CLOSE_DIALOG'
    }),
    destroyOnClose: true,
    children: dialog.component,
    width: dialog.width,
    footer: null
  }));
};

var _default = Master;
exports.default = _default;