"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _antd = require("antd");

var _lodash = require("lodash");

var _Input = _interopRequireDefault(require("./Input"));

var _ListItem = _interopRequireDefault(require("./ListItem"));

var _Tag = _interopRequireDefault(require("./Tag"));

var _utils = require("../utils");

var _store = require("../store");

var _templateObject;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const Menu = props => {
  var _sites$siteID, _sites$siteID$postTyp, _sites$siteID5;

  const {
    onAdd
  } = props;
  const [{
    cmsState: {
      sites,
      siteID
    }
  }] = (0, _store.useStore)();
  const [filter, setFilter] = (0, _react.useState)('page');
  const [link, setLink] = (0, _react.useState)({
    title: '',
    url: ''
  }); // Get posts by filter

  const postType = (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$postTyp = _sites$siteID.postTypes) === null || _sites$siteID$postTyp === void 0 ? void 0 : _sites$siteID$postTyp[filter];
  let posts = postType !== null && postType !== void 0 && postType.posts ? Object.values(postType.posts) : []; // Sort posts by menu order

  posts = posts.sort((a, b) => a.order > b.order ? 1 : -1); // Create data tree

  posts = (0, _utils.createDataTree)(posts);

  const handleAddLink = () => {
    if (!link.title || !link.url) {
      return;
    }

    onAdd(_objectSpread(_objectSpread({
      key: (0, _utils.generateRandomString)()
    }, link), {}, {
      postTypeID: null,
      postID: null,
      children: []
    }));
    setLink({
      title: '',
      url: ''
    });
  };

  const renderPost = (o, level) => {
    var _sites$siteID2, _sites$siteID3;

    const slug = "/".concat((0, _utils.generateSlug)(postType, o.id, sites === null || sites === void 0 ? void 0 : (_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : _sites$siteID2.frontPage));
    let badges = [];

    if ((sites === null || sites === void 0 ? void 0 : (_sites$siteID3 = sites[siteID]) === null || _sites$siteID3 === void 0 ? void 0 : _sites$siteID3.frontPage) === o.id) {
      badges.push( /*#__PURE__*/_react.default.createElement(_Tag.default, {
        key: "front",
        children: 'front'
      }));
    }

    if (o.status === 'draft' || o.status === 'trash') {
      badges.push( /*#__PURE__*/_react.default.createElement(_Tag.default, {
        key: "status",
        children: o.status
      }));
    }

    const actions = [];
    o.status === 'publish' && actions.push( /*#__PURE__*/_react.default.createElement(_antd.Button, {
      key: "add",
      onClick: () => {
        var _sites$siteID4;

        return onAdd({
          key: (0, _utils.generateRandomString)(),
          title: o.title,
          postTypeID: o.postTypeID,
          postID: o.id,
          children: [],
          url: (0, _utils.generateSlug)(postType, o.id, sites === null || sites === void 0 ? void 0 : (_sites$siteID4 = sites[siteID]) === null || _sites$siteID4 === void 0 ? void 0 : _sites$siteID4.frontPage, true)
        });
      }
    }, "Add"));
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
      key: o.id
    }, /*#__PURE__*/_react.default.createElement(_ListItem.default, {
      level: level,
      title: o.title,
      subtitle: slug,
      status: badges,
      showImage: false,
      disabled: o.status === 'draft',
      actions: actions
    }), o.childNodes.map(p => renderPost(p, level + 1)));
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    defaultActiveKey: filter,
    onChange: v => setFilter(v)
  }, /*#__PURE__*/_react.default.createElement(_antd.Tabs.TabPane, {
    key: 'page',
    tab: 'PAGE'
  }), Object.values((_sites$siteID5 = sites[siteID]) === null || _sites$siteID5 === void 0 ? void 0 : _sites$siteID5.postTypes).filter(o => o.id !== 'page').map(o => {
    return /*#__PURE__*/_react.default.createElement(_antd.Tabs.TabPane, {
      key: o.id,
      tab: o.id.toUpperCase()
    });
  }), /*#__PURE__*/_react.default.createElement(_antd.Tabs.TabPane, {
    key: 'link',
    tab: 'LINK'
  })), /*#__PURE__*/_react.default.createElement("div", null, filter === 'link' ? /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Title",
    value: link.title,
    onChange: e => setLink(_objectSpread(_objectSpread({}, link), {}, {
      title: e.target.value
    }))
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Url",
    value: link.url,
    onChange: e => setLink(_objectSpread(_objectSpread({}, link), {}, {
      url: e.target.value
    })),
    placeholder: "https://"
  }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    style: {
      marginBottom: 20
    },
    children: "Add",
    type: "primary",
    onClick: handleAddLink
  })) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, (0, _lodash.isEmpty)(posts) ? /*#__PURE__*/_react.default.createElement(EmptyContainer, null, /*#__PURE__*/_react.default.createElement(_antd.Empty, {
    imageStyle: {
      height: 120
    }
  })) : /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 4
  }, posts.filter((_ref) => {
    let {
      status
    } = _ref;
    return status !== 'trash';
  }).map(o => renderPost(o, 0))))));
};

const EmptyContainer = _styledComponents.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  width: 100%;\n  text-align: center;\n"])));

var _default = Menu;
exports.default = _default;