"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _router = require("@reach/router");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _lodash = require("lodash");

var _antd = require("antd");

var _store = require("../store");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const PageWrapper = props => {
  var _sites$siteID, _sites$siteID$editorO, _sites$siteID2, _sites$siteID2$editor;

  const {
    sidebarActive,
    loaded,
    locked,
    children
  } = props;
  const [{
    cmsState: {
      sites,
      siteID
    },
    editorState: {
      siteHasChanged,
      postHasChanged,
      changeIndex
    }
  }, dispatch] = (0, _store.useStore)(); // We need the window width to calculate scaling

  const [windowWidth, setWindowWidth] = (0, _react.useState)(null);
  (0, _react.useEffect)(() => {
    setWindowWidth(window.innerWidth);
  }, []);
  (0, _react.useEffect)(() => {
    const debouncedHandleResize = (0, _lodash.debounce)(() => {
      setWindowWidth(window.innerWidth);
    }, 100);
    window.addEventListener('resize', debouncedHandleResize);
    return () => {
      window.removeEventListener('resize', debouncedHandleResize);
    };
  }, []);
  (0, _react.useEffect)(() => {
    // Disable all links on the page as soon as the content has changed
    var anchors = document.querySelector('#jam-cms').querySelectorAll('a');

    for (var i = 0; i < anchors.length; i++) {
      anchors[i].onclick = e => {
        var _e$target;

        // Always allow links which open in a new browser tab
        if (((_e$target = e.target) === null || _e$target === void 0 ? void 0 : _e$target.target) === '_blank') {
          return true;
        }

        if (siteHasChanged || postHasChanged) {
          e.preventDefault(); // Display confirmation dialog

          dispatch({
            type: 'SET_DIALOG',
            payload: {
              open: true,
              title: 'Warning',
              component: /*#__PURE__*/_react.default.createElement(_antd.Space, {
                direction: "vertical",
                size: 20
              }, /*#__PURE__*/_react.default.createElement(_antd.Typography, {
                children: 'There are unsaved changes. Are you sure you want to discard them?'
              }), /*#__PURE__*/_react.default.createElement(_antd.Space, null, /*#__PURE__*/_react.default.createElement(_antd.Button, {
                children: "Cancel",
                onClick: () => dispatch({
                  type: 'CLOSE_DIALOG'
                })
              }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
                children: "Discard changes",
                type: "danger",
                onClick: () => {
                  var _e$path;

                  // Clicking on a tags with nested elements (i.e. span) returns the wrong 'target'. That's why we need to find the correct node ourselves.
                  const href = (e === null || e === void 0 ? void 0 : (_e$path = e.path) === null || _e$path === void 0 ? void 0 : _e$path.length) && e.path.find(o => o.href);

                  if (href) {
                    (0, _router.navigate)(href);
                  }

                  dispatch({
                    type: 'CLOSE_DIALOG'
                  });
                }
              }))),
              width: 320
            }
          });
        }
      };
    }
  }, [changeIndex]);
  return /*#__PURE__*/_react.default.createElement(Container, {
    id: "jam-cms",
    loaded: loaded,
    locked: locked,
    sidebar: _objectSpread({
      active: sidebarActive
    }, sites === null || sites === void 0 ? void 0 : (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$editorO = _sites$siteID.editorOptions) === null || _sites$siteID$editorO === void 0 ? void 0 : _sites$siteID$editorO.sidebar)
  }, /*#__PURE__*/_react.default.createElement(Inner, {
    loaded: loaded,
    locked: locked,
    sidebar: _objectSpread({
      active: sidebarActive
    }, sites === null || sites === void 0 ? void 0 : (_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : (_sites$siteID2$editor = _sites$siteID2.editorOptions) === null || _sites$siteID2$editor === void 0 ? void 0 : _sites$siteID2$editor.sidebar),
    windowWidth: windowWidth
  }, children));
};

const Container = _styledComponents.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  ", "\n"])), (_ref) => {
  let {
    loaded,
    locked,
    sidebar: {
      style,
      active
    }
  } = _ref;
  return loaded && !locked && style === 'scale' && active && (0, _styledComponents.css)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n      height: 100vh;\n    "])));
});

const Inner = _styledComponents.default.div(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n  ", "\n"])), (_ref2) => {
  let {
    loaded,
    locked,
    sidebar: {
      style,
      active,
      position,
      width
    },
    windowWidth
  } = _ref2;
  return loaded && !locked && (0, _styledComponents.css)(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2.default)(["\n      ", "\n    "])), style === 'scale' ? active && (0, _styledComponents.css)(_templateObject5 || (_templateObject5 = (0, _taggedTemplateLiteral2.default)(["\n            transform: ", ";\n            transform-origin: ", " top;\n          "])), windowWidth && "scale(".concat(1 - width / windowWidth, ")"), position === 'left' ? 'right' : 'left') : style === 'inline' ? (0, _styledComponents.css)(_templateObject6 || (_templateObject6 = (0, _taggedTemplateLiteral2.default)(["\n            width: ", ";\n            margin-left: ", ";\n            margin-right: ", ";\n          "])), active ? "calc(100% - ".concat(width, "px)") : '100%', position === 'left' && active ? "".concat(width, "px") : 0, position === 'right' && active ? "".concat(width, "px") : 0) : style === 'overflow' && (0, _styledComponents.css)(_templateObject7 || (_templateObject7 = (0, _taggedTemplateLiteral2.default)([""]))));
});

var _default = PageWrapper;
exports.default = _default;