"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _Input = _interopRequireDefault(require("./Input"));

var _Select = _interopRequireDefault(require("./Select"));

var _PostTreeSelect = _interopRequireDefault(require("./PostTreeSelect"));

var _store = require("../store");

// import app components
const PostForm = props => {
  var _sites$siteID, _sites$siteID$postTyp, _sites$siteID$postTyp2, _sites$siteID2;

  const {
    postTypeID: defaultPostTypeID,
    onSubmit
  } = props;
  const [{
    cmsState: {
      sites,
      siteID
    }
  }, dispatch] = (0, _store.useStore)();
  const [title, setTitle] = (0, _react.useState)('');
  const [postTypeID, setPostTypeID] = (0, _react.useState)(defaultPostTypeID || 'page');
  const [parentID, setParentID] = (0, _react.useState)(0);
  const posts = (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$postTyp = _sites$siteID.postTypes) === null || _sites$siteID$postTyp === void 0 ? void 0 : (_sites$siteID$postTyp2 = _sites$siteID$postTyp[postTypeID]) === null || _sites$siteID$postTyp2 === void 0 ? void 0 : _sites$siteID$postTyp2.posts;

  const handleSubmit = async () => {
    if (!title) {
      return;
    }

    await onSubmit({
      postTypeID,
      title,
      parentID
    });
    setTitle('');
    setParentID(0);
    dispatch({
      type: 'CLOSE_DIALOG'
    });
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Title",
    value: title,
    onChange: e => setTitle(e.target.value),
    placeholder: '',
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), !defaultPostTypeID && ((_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : _sites$siteID2.postTypes) && Object.values(sites[siteID].postTypes).length > 1 && /*#__PURE__*/_react.default.createElement(_Select.default, {
    label: "Post Type",
    value: postTypeID,
    onChange: v => setPostTypeID(v)
  }, Object.values(sites[siteID].postTypes).map(o => /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    key: o.id,
    value: o.id,
    children: o.title
  }))), postTypeID === 'page' && /*#__PURE__*/_react.default.createElement(_PostTreeSelect.default, {
    label: "Parent",
    items: Object.values(posts),
    value: parentID,
    onChange: value => setParentID(value)
  }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: "Add",
    onClick: handleSubmit,
    type: "primary",
    disabled: !title
  }));
};

var _default = PostForm;
exports.default = _default;