"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _Caption = _interopRequireDefault(require("./Caption"));

var _utils = require("../utils");

// import app components
const PostTreeSelect = props => {
  const {
    items = [],
    value,
    label,
    onChange
  } = props;
  const tree = (0, _react.useMemo)(() => {
    const treePosts = (0, _utils.createDataTree)(items);

    const renderTreeNode = item => {
      return /*#__PURE__*/_react.default.createElement(_antd.TreeSelect.TreeNode, {
        key: item.id,
        value: item.id,
        title: item.title
      }, item.childNodes.map(o => renderTreeNode(o)));
    };

    return /*#__PURE__*/_react.default.createElement(_antd.TreeSelect, {
      showSearch: true,
      treeNodeFilterProp: "title",
      value: value,
      treeDefaultExpandAll: true,
      onChange: onChange,
      getPopupContainer: triggerNode => triggerNode.parentNode
    }, /*#__PURE__*/_react.default.createElement(_antd.TreeSelect.TreeNode, {
      value: 0,
      title: "None"
    }), treePosts.map(o => renderTreeNode(o)));
  }, [value]);
  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 6
  }, /*#__PURE__*/_react.default.createElement(_Caption.default, {
    children: label
  }), tree);
};

var _default = PostTreeSelect;
exports.default = _default;