"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _htmlReactParser = _interopRequireDefault(require("html-react-parser"));

var _gatsby = require("gatsby");

const RichText = props => {
  const {
    children
  } = props;

  const parse = string => {
    return typeof string === 'string' ? (0, _htmlReactParser.default)(string, {
      replace: domNode => {
        if (domNode.type === 'tag') {
          if (domNode.name === 'a') {
            if (domNode.attribs.href.includes('http')) {
              return /*#__PURE__*/_react.default.createElement("a", {
                href: domNode.attribs.href,
                target: "_blank"
              }, domNode.children.map(o => parse(o.data)));
            } else if (domNode.attribs.href.includes('tel:') || domNode.attribs.href.includes('mailto:')) {
              return /*#__PURE__*/_react.default.createElement("a", {
                href: domNode.attribs.href
              }, domNode.children.map(o => parse(o.data)));
            } else {
              return /*#__PURE__*/_react.default.createElement(_gatsby.Link, {
                to: domNode.attribs.href
              }, domNode.children.map(o => parse(o.data)));
            }
          } // Remove all special characters from string. This is necessary when using the code editor and start adding html elements.


          domNode.name = domNode.name.replace(/[^a-zA-Z1-9 ]/g, '');
        }
      }
    }) : '';
  };

  return parse(children);
};

var _default = RichText;
exports.default = _default;