"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _router = require("@reach/router");

var _Input = _interopRequireDefault(require("./Input"));

var _auth = require("../utils/auth");

var _actions = require("../actions");

var _store = require("../store");

var _routes = _interopRequireDefault(require("../routes"));

// import app components
const SiteForm = () => {
  const [{
    config
  }, dispatch] = (0, _store.useStore)();
  const [title, setTitle] = (0, _react.useState)('');
  const [loading, setLoading] = (0, _react.useState)(false);

  const handleSubmit = async () => {
    if (!title) {
      return;
    }

    setLoading(true);
    const result = await _actions.siteActions.addSite({
      ownerID: (0, _auth.getCurrentUser)(config).sub,
      title
    }, dispatch, config);

    if (result) {
      (0, _router.navigate)((0, _routes.default)("dashboard", {
        siteID: result.id
      }));
    }

    setLoading(false);
    dispatch({
      type: 'CLOSE_DIALOG'
    });
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical"
  }, /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Title",
    value: title,
    onChange: e => setTitle(e.target.value),
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    loading: loading,
    children: "Add",
    onClick: handleSubmit,
    type: "primary"
  }));
};

var _default = SiteForm;
exports.default = _default;