"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _Select = _interopRequireDefault(require("./Select"));

var _Input = _interopRequireDefault(require("./Input"));

var _store = require("../store");

// import app components
const TaxonomyForm = props => {
  const {
    site,
    id: defaultId,
    title: defaultTitle = '',
    slug: defaultSlug = '',
    postTypes: defaultPostTypes = [],
    onSubmit
  } = props;
  const taxonomyExists = !!defaultId;
  const [, dispatch] = (0, _store.useStore)();
  const [title, setTitle] = (0, _react.useState)(defaultTitle);
  const [id, setId] = (0, _react.useState)(defaultId);
  const [slug, setSlug] = (0, _react.useState)(defaultSlug);
  const [postTypes, setPostTypes] = (0, _react.useState)(defaultPostTypes);

  const handleSubmit = async () => {
    if (!title || !id) {
      return;
    }

    await onSubmit({
      id,
      title,
      slug,
      postTypes
    });
    dispatch({
      type: 'CLOSE_DIALOG'
    });
  };

  const handleChangeId = e => {
    const formattedId = e.target.value.replace(/[^a-zA-Z ]/g, '').toLowerCase();
    setId(formattedId);
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical"
  }, /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Title",
    value: title,
    onChange: e => setTitle(e.target.value),
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "name",
    value: id,
    instructions: "The id must match the template file id (i.e. post)",
    onChange: handleChangeId,
    disabled: taxonomyExists,
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "slug",
    value: slug,
    onChange: e => setSlug(e.target.value),
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_Select.default, {
    label: "Collections",
    mode: "multiple",
    allowClear: true,
    style: {
      width: '100%'
    },
    placeholder: "Please select",
    defaultValue: postTypes,
    onChange: v => setPostTypes(v)
  }, (site === null || site === void 0 ? void 0 : site.postTypes) && Object.values(site.postTypes).map(o => /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    key: o.id,
    value: o.id,
    children: o.title
  })))), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: taxonomyExists ? 'Update' : 'Add',
    onClick: handleSubmit,
    type: "primary",
    block: true
  }));
};

var _default = TaxonomyForm;
exports.default = _default;