"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _immer = _interopRequireDefault(require("immer"));

var _antd = require("antd");

const Checkbox = props => {
  const {
    value,
    options,
    onChange
  } = props;
  const values = value || [];

  const handleChange = e => {
    const {
      target: {
        checked,
        value
      }
    } = e;
    const newValues = (0, _immer.default)(values, draft => {
      if (checked) {
        draft.push(value);
      } else {
        draft = draft.filter(v => v !== value);
      }

      return draft;
    });
    onChange(newValues);
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, options && options.map(o => /*#__PURE__*/_react.default.createElement(_antd.Checkbox, {
    key: o.value,
    value: o.value,
    checked: values.includes(o.value),
    children: o.name,
    onChange: handleChange
  })));
};

var _default = Checkbox;
exports.default = _default;