"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _moment = _interopRequireDefault(require("moment"));

const DatePicker = props => {
  const {
    value,
    defaultValue,
    format = 'DD/MM/YYYY',
    onChange: _onChange
  } = props;
  (0, _react.useEffect)(() => {
    if (!value && !defaultValue) {
      // Add fallback date in case no value or default value is provided
      const now = new Date();
      const formattedDate = (0, _moment.default)(now).format(format);

      _onChange(formattedDate);
    }
  }, [value, defaultValue]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, (value || defaultValue) && /*#__PURE__*/_react.default.createElement(_antd.DatePicker, {
    value: (0, _moment.default)(value || defaultValue, format),
    onChange: value => _onChange(value ? value._d : ''),
    allowClear: false
  }));
};

var _default = DatePicker;
exports.default = _default;