"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _htmlReactParser = _interopRequireDefault(require("html-react-parser"));

var _CmsLayout = _interopRequireDefault(require("../components/CmsLayout"));

var _actions = require("../actions");

var _store = require("../store");

var _package = require("../../package.json");

// import app components
const Dashboard = () => {
  var _sites$siteID, _sites$siteID$deploym, _sites$siteID3, _sites$siteID3$deploy;

  const [{
    config,
    cmsState: {
      sites,
      siteID
    }
  }, dispatch] = (0, _store.useStore)();
  const [changes, setChanges] = (0, _react.useState)(null);
  const lastBuild = sites === null || sites === void 0 ? void 0 : (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$deploym = _sites$siteID.deployment) === null || _sites$siteID$deploym === void 0 ? void 0 : _sites$siteID$deploym.lastBuild;
  (0, _react.useEffect)(() => {
    const getUnpublishedChanges = async () => {
      const result = await _actions.siteActions.getUnpublishedChanges({
        siteID
      }, dispatch, config);

      if (result) {
        setChanges(result);
      }
    };

    getUnpublishedChanges();
  }, [lastBuild]);

  const handleDeploy = async () => {
    var _sites$siteID2, _sites$siteID2$deploy;

    await _actions.siteActions.deploySite({
      id: siteID
    }, dispatch, config);

    if (sites !== null && sites !== void 0 && (_sites$siteID2 = sites[siteID]) !== null && _sites$siteID2 !== void 0 && (_sites$siteID2$deploy = _sites$siteID2.deployment) !== null && _sites$siteID2$deploy !== void 0 && _sites$siteID2$deploy.badgeImage) {
      dispatch({
        type: 'SET_DEPLOYMENT_IMAGE',
        payload: "".concat(sites[siteID].deployment.badgeImage, "?v=").concat(Math.floor(Math.random() * Math.floor(100)))
      });
    }
  };

  const deploymentButton = sites !== null && sites !== void 0 && (_sites$siteID3 = sites[siteID]) !== null && _sites$siteID3 !== void 0 && (_sites$siteID3$deploy = _sites$siteID3.deployment) !== null && _sites$siteID3$deploy !== void 0 && _sites$siteID3$deploy.buildHook ? [/*#__PURE__*/_react.default.createElement(_antd.Button, {
    key: "deploy",
    type: "primary",
    onClick: handleDeploy,
    children: "Deploy Website"
  })] : null;
  return /*#__PURE__*/_react.default.createElement(_CmsLayout.default, {
    pageTitle: "Dashboard"
  }, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 40
  }, /*#__PURE__*/_react.default.createElement(_antd.Card, {
    title: "Unpublished changes",
    extra: deploymentButton
  }, changes === null ? /*#__PURE__*/_react.default.createElement(_antd.Skeleton, {
    paragraph: {
      rows: 4
    },
    active: true
  }) : changes !== null && changes !== void 0 && changes.length ? /*#__PURE__*/_react.default.createElement(_antd.List, {
    dataSource: changes,
    renderItem: o => /*#__PURE__*/_react.default.createElement(_antd.List.Item, {
      actions: [/*#__PURE__*/_react.default.createElement("span", {
        key: "type"
      }, o.actionType)]
    }, /*#__PURE__*/_react.default.createElement(_antd.List.Item.Meta, {
      title: (0, _htmlReactParser.default)(o.title || ''),
      description: (0, _htmlReactParser.default)(o.description || '')
    }))
  }) : /*#__PURE__*/_react.default.createElement(_antd.Empty, {
    description: 'No changes'
  })), /*#__PURE__*/_react.default.createElement(_antd.Typography.Text, {
    type: "secondary"
  }, "Version: ", _package.version)));
};

var _default = Dashboard;
exports.default = _default;