"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _router = require("@reach/router");

var _antd = require("antd");

var _BaseLayout = _interopRequireDefault(require("../components/BaseLayout"));

var _Edges = _interopRequireDefault(require("../components/Edges"));

var _SiteForm = _interopRequireDefault(require("../components/SiteForm"));

var _ListItem = _interopRequireDefault(require("../components/ListItem"));

var _Loader = _interopRequireDefault(require("../components/Loader"));

var _actions = require("../actions");

var _store = require("../store");

var _routes = _interopRequireDefault(require("../routes"));

// import app components
const Home = () => {
  const [{
    config,
    cmsState: {
      sites
    }
  }, dispatch] = (0, _store.useStore)();
  const [loaded, setLoaded] = (0, _react.useState)(false);
  (0, _react.useEffect)(() => {
    const loadSites = async () => {
      if (!!config.multisite) {
        await _actions.siteActions.getSites({}, dispatch, config);
      } else {
        (0, _router.navigate)((0, _routes.default)("dashboard"));
      }

      setLoaded(true);
    };

    loadSites();
  }, []);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, loaded ? /*#__PURE__*/_react.default.createElement(_BaseLayout.default, null, /*#__PURE__*/_react.default.createElement(_Edges.default, {
    size: "md"
  }, /*#__PURE__*/_react.default.createElement(_antd.PageHeader, {
    title: "My Websites",
    extra: [/*#__PURE__*/_react.default.createElement(_antd.Button, {
      key: "1",
      onClick: () => dispatch({
        type: 'SET_DIALOG',
        payload: {
          open: true,
          title: 'Add Website',
          component: /*#__PURE__*/_react.default.createElement(_SiteForm.default, null)
        }
      }),
      type: "primary",
      children: "Add Site"
    })]
  }), /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical"
  }, Object.keys(sites).map(key => {
    const {
      id,
      title
    } = sites[key];
    return /*#__PURE__*/_react.default.createElement(_ListItem.default, {
      key: id,
      title: title,
      actions: [/*#__PURE__*/_react.default.createElement(_antd.Button, {
        key: "1",
        onClick: () => (0, _router.navigate)((0, _routes.default)("dashboard", {
          siteID: id
        })),
        children: "Dashboard"
      })],
      link: (0, _routes.default)("dashboard", {
        siteID: id
      })
    });
  })))) : /*#__PURE__*/_react.default.createElement(_Loader.default, null));
};

var _default = Home;
exports.default = _default;