"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _axios = _interopRequireDefault(require("axios"));

var _lodash = require("lodash");

var _reactUseKeypress = _interopRequireDefault(require("react-use-keypress"));

var _router = require("@reach/router");

var _PageWrapper = _interopRequireDefault(require("../components/PageWrapper"));

var _Loader = _interopRequireDefault(require("../components/Loader"));

var _EditorSidebar = _interopRequireDefault(require("../components/EditorSidebar"));

var _utils = require("../utils");

var _store = require("../store");

var _actions = require("../actions");

var _routes = _interopRequireDefault(require("../routes"));

var _templateObject, _templateObject2, _templateObject3;

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const PostEditor = props => {
  var _sites$siteID, _sites$siteID$editorO, _sites$siteID$editorO2, _sites$siteID3, _post$locked2, _sites$siteID5, _sites$siteID6, _sites$siteID6$editor, _sites$siteID7, _sites$siteID7$editor, _sites$siteID7$editor2, _sites$siteID8, _sites$siteID8$editor, _sites$siteID8$editor2;

  const {
    defaultComponent
  } = props;
  const [{
    config,
    cmsState: {
      sites,
      siteID
    },
    editorState: {
      site,
      post,
      editorSettings
    }
  }, dispatch] = (0, _store.useStore)();
  const {
    fields
  } = config;

  const previewID = _utils.auth.isPreview(); // Timer for lock check


  const [postLockTimer, setPostLockTimer] = (0, _react.useState)(0); // We need to store the post ID so we can remove the lock when navigating to a different page (old ID won't be available anymore)

  const [postLockID, setPostLockID] = (0, _react.useState)(null); // GraphQL query result

  const [query, setQuery] = (0, _react.useState)(null); // Determine if sidebar should be open on default when visiting the editor

  let sidebarActiveDefault = false;

  if (sites !== null && sites !== void 0 && (_sites$siteID = sites[siteID]) !== null && _sites$siteID !== void 0 && (_sites$siteID$editorO = _sites$siteID.editorOptions) !== null && _sites$siteID$editorO !== void 0 && (_sites$siteID$editorO2 = _sites$siteID$editorO.sidebar) !== null && _sites$siteID$editorO2 !== void 0 && _sites$siteID$editorO2.defaultOpen && !previewID) {
    sidebarActiveDefault = true;
  }

  const [sidebarActive, setSidebarActive] = (0, _react.useState)(sidebarActiveDefault);
  const template = (0, _utils.getTemplateByPost)(post, fields);
  const Component = template === null || template === void 0 ? void 0 : template.component;
  const pathname = window.location.pathname.replace(/\/$/, '');

  const isNumber = n => {
    return !isNaN(parseFloat(n)) && !isNaN(n - 0);
  }; // The post id is only available during initial load so we need to look it up ourselves by searching through all pages


  const postID = (0, _react.useMemo)(() => {
    let postID = '';

    if (sites[siteID]) {
      Object.values(sites[siteID].postTypes).map(o => Object.values(o.posts).map(p => {
        var _sites$siteID2;

        const slug = (0, _utils.generateSlug)(o, p.id, sites === null || sites === void 0 ? void 0 : (_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : _sites$siteID2.frontPage, true);

        if (slug === "".concat(pathname, "/")) {
          postID = p.id;
        } else if ( // We're assuming here that there is not conflicting page which has the format '/[blog]/page/2'
        pathname.startsWith("".concat(slug, "page/")) && isNumber(pathname.substring(pathname.lastIndexOf('/') + 1))) {
          postID = p.id;
        }
      }));
    }

    return postID;
  }, [pathname]); // We need to check if post is front page to return the correct basePath for pagination

  const isFrontPage = postID === (sites === null || sites === void 0 ? void 0 : (_sites$siteID3 = sites[siteID]) === null || _sites$siteID3 === void 0 ? void 0 : _sites$siteID3.frontPage); // The pagination object will be available once we have the post id and therefore template id

  const pagination = (0, _react.useMemo)(() => {
    let pagination = {};

    if ((template === null || template === void 0 ? void 0 : template.id) === 'archive') {
      var _config$settings, _sites$siteID4, _sites$siteID4$postTy, _sites$siteID4$postTy2;

      // Get the page number if exists
      const page = isNumber(pathname.substring(pathname.lastIndexOf('/') + 1)) ? parseInt(pathname.substring(pathname.lastIndexOf('/') + 1)) : 1;
      const postsPerPage = (config === null || config === void 0 ? void 0 : (_config$settings = config.settings) === null || _config$settings === void 0 ? void 0 : _config$settings.postsPerPage) || 10;
      const numberOfPosts = Object.values((sites === null || sites === void 0 ? void 0 : (_sites$siteID4 = sites[siteID]) === null || _sites$siteID4 === void 0 ? void 0 : (_sites$siteID4$postTy = _sites$siteID4.postTypes) === null || _sites$siteID4$postTy === void 0 ? void 0 : (_sites$siteID4$postTy2 = _sites$siteID4$postTy[template === null || template === void 0 ? void 0 : template.postTypeID]) === null || _sites$siteID4$postTy2 === void 0 ? void 0 : _sites$siteID4$postTy2.posts) || {}).filter(o => o.status === 'publish').length;
      pagination = {
        basePath: isFrontPage ? '/' : "/".concat(post.slug, "/"),
        numberOfPosts,
        postsPerPage,
        numberOfPages: Math.ceil(numberOfPosts / postsPerPage),
        page
      };
    }

    return pagination;
  }, [isFrontPage, template === null || template === void 0 ? void 0 : template.id, pathname]); // The 'true' template id is a combination of id and post type

  const templateID = "".concat(template === null || template === void 0 ? void 0 : template.id, "-").concat(template === null || template === void 0 ? void 0 : template.postTypeID);
  let loaded = false; // Check if post editor is ready

  if (site && (post === null || post === void 0 ? void 0 : post.id) === postID) {
    loaded = true;
  } // If there is a query, we need to wait for it


  if (template !== null && template !== void 0 && template.query && !query) {
    loaded = false;
  } // For the post lock functionality we need 4 useEffect functions to cover the whole process
  // 1. Set up interval function on initial load and remove post lock in case user leaves the editor
  // 2. Refresh the lock status every couple of seconds or check if post is still locked
  // 3. Inform user who is currently editing the post by displaying the take over dialog
  // 4. Remove lock status from old post in case user navigates away via editor link


  (0, _react.useEffect)(() => {
    // Activate postLockTimer for post locking
    const intervalID = setInterval(() => {
      !previewID && setPostLockTimer(time => time + 1);
    }, 60000); // 60 seconds

    return async () => {
      clearInterval(intervalID);

      if (post && post.id === postID && !post.locked && !previewID) {
        // Remove post lock once we leave the post editor
        await removePostLock(postID);
      }
    };
  }, []);
  (0, _react.useEffect)(() => {
    // Skip initial fetch (postLockTimer = 0) because we're already setting the status on initial getPost fetch in WP
    if (postID && post && post.id === postID && postLockTimer && !previewID) {
      if (post !== null && post !== void 0 && post.locked) {
        // Fetch post again in case it's locked to determine if other user is still editing
        loadPost();
      } else {
        // Refresh the post lock status to inform WordPress that we are still editing
        refreshPostLock();
      }
    }
  }, [postLockTimer]);
  (0, _react.useEffect)(() => {
    // Remove previous post ID in case user navigates to a different page
    if (postLockID) {
      removePostLock(postLockID);
    } // Set new post id


    setPostLockID(postID);
  }, [postID]);
  (0, _react.useEffect)(() => {
    var _post$locked;

    if (post !== null && post !== void 0 && (_post$locked = post.locked) !== null && _post$locked !== void 0 && _post$locked.id && !previewID) {
      handleOpenTakeOverDialog();
    }
  }, [post === null || post === void 0 ? void 0 : (_post$locked2 = post.locked) === null || _post$locked2 === void 0 ? void 0 : _post$locked2.id]); // Load query in case post has one assigned

  (0, _react.useEffect)(() => {
    const loadQuery = async () => {
      // TODO: Move to utils function
      const cleanedUrl = config === null || config === void 0 ? void 0 : config.source.replace(/\/+$/, '');
      const result = await _axios.default.post("".concat(cleanedUrl, "/graphql"), {
        query: template.query
      });

      if (result !== null && result !== void 0 && result.data) {
        setQuery(result.data);
      }
    };

    (template === null || template === void 0 ? void 0 : template.query) && loadQuery();
  }, [templateID]);
  (0, _react.useEffect)(() => {
    loadPost(); // Add fresh copy of editor to state

    dispatch({
      type: "ADD_EDITOR_SITE",
      payload: sites[siteID]
    }); // Reset query

    setQuery(null);
    return () => dispatch({
      type: "CLEAR_EDITOR"
    });
  }, [postID]);
  (0, _reactUseKeypress.default)('Escape', () => {
    !previewID && !editorSettings.fullscreen && setSidebarActive(!sidebarActive);
  });

  const loadPost = async () => {
    if (!postID) {
      return;
    }

    let result;

    if (previewID) {
      result = await _actions.previewActions.getPostPreview({
        siteID,
        previewID
      }, dispatch, config);
    } else {
      result = await _actions.postActions.getPost({
        siteID,
        postID
      }, dispatch, config);
    }

    if (result) {
      dispatch({
        type: 'ADD_POST',
        payload: _objectSpread(_objectSpread({}, result), {}, {
          siteID
        })
      });
      dispatch({
        type: 'ADD_EDITOR_POST',
        payload: _objectSpread(_objectSpread({}, result), {}, {
          siteID
        })
      });
    }
  };

  const handleTakeOver = async () => {
    await _actions.postActions.takeOverPost({
      siteID,
      id: postID
    }, dispatch, config);
  };

  const handleOpenTakeOverDialog = () => {
    dispatch({
      type: 'SET_DIALOG',
      payload: {
        open: true,
        title: 'Locked',
        component: /*#__PURE__*/_react.default.createElement(_antd.Space, {
          direction: "vertical",
          size: 20
        }, /*#__PURE__*/_react.default.createElement(_antd.Typography.Text, null, "This content is currently locked. If you take over, ", post.locked.email, " will be blocked from continuing to edit."), /*#__PURE__*/_react.default.createElement(_antd.Space, null, /*#__PURE__*/_react.default.createElement(_antd.Button, {
          onClick: () => {
            dispatch({
              type: 'CLOSE_DIALOG'
            });
            (0, _router.navigate)((0, _routes.default)("collection", {
              siteID,
              postTypeID: (post === null || post === void 0 ? void 0 : post.postTypeID) || 'page'
            }));
          },
          children: "Dashboard"
        }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
          onClick: () => dispatch({
            type: 'CLOSE_DIALOG'
          }),
          children: "Preview"
        }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
          onClick: handleTakeOver,
          type: "primary",
          children: "Take Over"
        })))
      }
    });
  };

  const refreshPostLock = async () => {
    await _actions.postActions.refreshPostLock({
      siteID,
      id: postID
    }, dispatch, config);
  };

  const removePostLock = async id => {
    await _actions.postActions.removePostLock({
      siteID,
      id
    }, dispatch, config);
  };

  const handleToggleSidebar = () => {
    if (sidebarActive) {
      _antd.message.open({
        content: /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, "Press ", /*#__PURE__*/_react.default.createElement(_antd.Typography.Text, {
          keyboard: true
        }, "ESC"), " to reopen sidebar")
      });
    }

    setSidebarActive(!sidebarActive);
  };

  const getPostData = () => {
    // Generate query variable i.e. 'wpPage'
    const nodeType = "wp".concat(post.postTypeID.charAt(0).toUpperCase() + post.postTypeID.slice(1)); // Destructure query data in case user requested more information about post (i.e. wpPost comments)

    const _ref = (query === null || query === void 0 ? void 0 : query.data) || {},
          {
      [nodeType]: nodeTypeQueryData
    } = _ref,
          otherQueryData = (0, _objectWithoutProperties2.default)(_ref, [nodeType].map(_toPropertyKey)); // Generate default page data


    const data = _objectSpread({}, otherQueryData);

    const nodeTypeData = _objectSpread({
      id: post.id,
      seo: post.seo,
      title: post.title,
      date: post.createdAt,
      featuredImage: post.featuredImage,
      postTypeID: post.postTypeID
    }, (0, _utils.formatTaxonomiesForEditor)(post, site));

    data[nodeType] = _objectSpread(_objectSpread({}, nodeTypeQueryData), nodeTypeData);
    const acfData = (0, _utils.formatFieldsToProps)({
      global: false,
      content: post.content,
      site,
      template
    });

    if (post.postTypeID === 'page') {
      (0, _lodash.set)(data, "".concat(nodeType, ".template.acf"), acfData);
    } else {
      (0, _lodash.set)(data, "".concat(nodeType, ".acf"), acfData);
    }

    return data;
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_PageWrapper.default, {
    sidebarActive: sidebarActive,
    loaded: loaded,
    locked: !!(post !== null && post !== void 0 && post.locked)
  }, postID ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, loaded ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, !!Component && post !== null && post !== void 0 && post.content ? /*#__PURE__*/_react.default.createElement(Component, {
    data: getPostData(),
    pageContext: {
      siteTitle: sites === null || sites === void 0 ? void 0 : (_sites$siteID5 = sites[siteID]) === null || _sites$siteID5 === void 0 ? void 0 : _sites$siteID5.title,
      jamCMS: {
        sidebar: _objectSpread({
          active: sidebarActive
        }, sites === null || sites === void 0 ? void 0 : (_sites$siteID6 = sites[siteID]) === null || _sites$siteID6 === void 0 ? void 0 : (_sites$siteID6$editor = _sites$siteID6.editorOptions) === null || _sites$siteID6$editor === void 0 ? void 0 : _sites$siteID6$editor.sidebar)
      },
      themeOptions: (0, _utils.formatFieldsToProps)({
        global: true,
        themeOptions: fields === null || fields === void 0 ? void 0 : fields.themeOptions,
        content: site === null || site === void 0 ? void 0 : site.themeOptions,
        site,
        template
      }),
      pagination
    }
  }) : /*#__PURE__*/_react.default.createElement(EmptyContainer, {
    className: "jam-cms"
  }, /*#__PURE__*/_react.default.createElement(_antd.Empty, {
    imageStyle: {
      height: 120
    },
    description: 'No Template'
  }))) : /*#__PURE__*/_react.default.createElement(_Loader.default, null)) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.cloneElement(defaultComponent, {
    pageContext: {
      pagination,
      themeOptions: (0, _utils.formatFieldsToProps)({
        themeOptions: fields === null || fields === void 0 ? void 0 : fields.themeOptions,
        content: site === null || site === void 0 ? void 0 : site.themeOptions,
        site
      })
    }
  }))), previewID ? /*#__PURE__*/_react.default.createElement(PreviewBanner, {
    children: "Preview",
    type: "primary"
  }) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, loaded && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, post !== null && post !== void 0 && post.locked ? /*#__PURE__*/_react.default.createElement(FloatingButton, {
    sidebarPosition: sites === null || sites === void 0 ? void 0 : (_sites$siteID7 = sites[siteID]) === null || _sites$siteID7 === void 0 ? void 0 : (_sites$siteID7$editor = _sites$siteID7.editorOptions) === null || _sites$siteID7$editor === void 0 ? void 0 : (_sites$siteID7$editor2 = _sites$siteID7$editor.sidebar) === null || _sites$siteID7$editor2 === void 0 ? void 0 : _sites$siteID7$editor2.position
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.LockOutlined, null),
    onClick: handleOpenTakeOverDialog,
    size: "large",
    type: "primary"
  })) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, sidebarActive ? /*#__PURE__*/_react.default.createElement(_EditorSidebar.default, {
    className: "jam-cms",
    editable: !!Component,
    onToggleSidebar: handleToggleSidebar
  }) : /*#__PURE__*/_react.default.createElement(FloatingButton, {
    sidebarPosition: sites === null || sites === void 0 ? void 0 : (_sites$siteID8 = sites[siteID]) === null || _sites$siteID8 === void 0 ? void 0 : (_sites$siteID8$editor = _sites$siteID8.editorOptions) === null || _sites$siteID8$editor === void 0 ? void 0 : (_sites$siteID8$editor2 = _sites$siteID8$editor.sidebar) === null || _sites$siteID8$editor2 === void 0 ? void 0 : _sites$siteID8$editor2.position
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.EditOutlined, null),
    onClick: handleToggleSidebar,
    size: "large",
    type: "primary"
  }))))));
};

const EmptyContainer = _styledComponents.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  height: 100vh;\n  text-align: center;\n"])));

const PreviewBanner = (0, _styledComponents.default)(_antd.Button)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n  position: fixed;\n  left: 0;\n  top: 50%;\n  z-index: 9999;\n  transform: rotate(270deg) translate(-50%, 50%);\n  transform-origin: left;\n"])));

const FloatingButton = _styledComponents.default.div(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n  position: fixed;\n  left: ", ";\n  right: ", ";\n  bottom: 200px;\n  z-index: 99999;\n\n  .ant-btn-icon-only.ant-btn-lg {\n    border-radius: ", ";\n  }\n"])), (_ref2) => {
  let {
    sidebarPosition
  } = _ref2;
  return sidebarPosition === 'left' ? 0 : 'unset';
}, (_ref3) => {
  let {
    sidebarPosition
  } = _ref3;
  return sidebarPosition === 'left' ? 'unset' : 0;
}, (_ref4) => {
  let {
    sidebarPosition
  } = _ref4;
  return sidebarPosition === 'left' ? '0 2px 2px 0' : '2px 0 0 2px';
});

var _default = PostEditor;
exports.default = _default;