"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _router = require("@reach/router");

var _antd = require("antd");

var _immer = _interopRequireDefault(require("immer"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _CmsLayout = _interopRequireDefault(require("../components/CmsLayout"));

var _PostForm = _interopRequireDefault(require("../components/PostForm"));

var _ListItem = _interopRequireDefault(require("../components/ListItem"));

var _Tag = _interopRequireDefault(require("../components/Tag"));

var _actions = require("../actions");

var _store = require("../store");

var _utils = require("../utils");

var _theme = require("../theme");

var _routes = _interopRequireDefault(require("../routes"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const PostType = props => {
  var _sites$siteID, _sites$siteID$postTyp, _sites$siteID2, _config$fields2, _config$fields2$postT, _config$fields2$postT2;

  const {
    postTypeID
  } = props;
  const [{
    config,
    cmsState: {
      sites,
      siteID
    }
  }, dispatch] = (0, _store.useStore)();
  const [filter, setFilter] = (0, _react.useState)('all');
  const [category, setCategory] = (0, _react.useState)('');
  const [search, setSearch] = (0, _react.useState)('');
  const [isSyncing, setIsSyncing] = (0, _react.useState)(false);
  const postType = (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$postTyp = _sites$siteID.postTypes) === null || _sites$siteID$postTyp === void 0 ? void 0 : _sites$siteID$postTyp[postTypeID];
  const posts = postType !== null && postType !== void 0 && postType.posts ? Object.values(postType.posts) : [];
  let visiblePosts = []; // Filter by category

  visiblePosts = !!category ? posts.filter(o => {
    var _o$taxonomies, _o$taxonomies$categor;

    return o === null || o === void 0 ? void 0 : (_o$taxonomies = o.taxonomies) === null || _o$taxonomies === void 0 ? void 0 : (_o$taxonomies$categor = _o$taxonomies[category === null || category === void 0 ? void 0 : category.taxonomy]) === null || _o$taxonomies$categor === void 0 ? void 0 : _o$taxonomies$categor.includes(category.term);
  }) : posts; // Filter by post status

  visiblePosts = filter === 'all' ? visiblePosts.filter(o => o.status !== 'trash') : visiblePosts.filter(o => o.status === filter); // Filter by search query

  visiblePosts = search ? visiblePosts.filter(o => o.title.toLowerCase().includes(search)) : visiblePosts; // Sort posts by menu order

  visiblePosts = visiblePosts.sort((a, b) => a.order > b.order ? 1 : -1); // Create data tree

  visiblePosts = (0, _utils.createDataTree)(visiblePosts);
  const taxonomies = Object.values(sites === null || sites === void 0 ? void 0 : (_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : _sites$siteID2.taxonomies).filter(o => o === null || o === void 0 ? void 0 : o.postTypes.includes(postTypeID));
  (0, _react.useEffect)(() => {
    var _config$fields, _config$fields$postTy;

    // Navigate to dashboard if template not found in fields object
    if (!(config !== null && config !== void 0 && (_config$fields = config.fields) !== null && _config$fields !== void 0 && (_config$fields$postTy = _config$fields.postTypes) !== null && _config$fields$postTy !== void 0 && _config$fields$postTy[postTypeID])) {
      (0, _router.navigate)((0, _routes.default)('dashboard', {
        siteID
      }));
    }
  }, []);

  const handleSync = async () => {
    var _sites$siteID3;

    setIsSyncing(true);
    await _actions.siteActions.syncFields({
      fields: config.fields,
      apiKey: (_sites$siteID3 = sites[siteID]) === null || _sites$siteID3 === void 0 ? void 0 : _sites$siteID3.apiKey
    }, dispatch, config);
    setIsSyncing(false);
  };

  const handleDuplicatePost = async (_ref) => {
    let {
      postID
    } = _ref;
    await _actions.postActions.duplicatePost({
      siteID,
      id: postID
    }, dispatch, config);
  };

  const handleDeletePost = async (_ref2) => {
    let {
      postID
    } = _ref2;
    await _actions.postActions.deletePost({
      siteID,
      id: postID
    }, dispatch, config);
  };

  const handleAddPost = async (_ref3) => {
    let {
      postTypeID,
      title,
      parentID
    } = _ref3;
    await (0, _utils.addPost)({
      site: sites[siteID],
      postTypeID,
      title,
      parentID
    }, dispatch, config);
  };

  const handleTrashPost = async (_ref4) => {
    let {
      postID
    } = _ref4;
    const result = await _actions.postActions.updatePost({
      siteID,
      postTypeID,
      id: postID,
      status: 'trash'
    }, dispatch, config);

    if (result) {
      _antd.message.info('Post has been trashed');
    }
  };

  const handleEmptyTrash = async () => {
    const result = await _actions.postActions.emptyTrash({
      siteID,
      postTypeID
    }, dispatch, config);

    if (result) {
      _antd.message.info({
        content: 'Trashed emptied successfully'
      });
    }
  };

  const filterItems = /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    defaultActiveKey: "all",
    onChange: v => setFilter(v)
  }, ['all', 'publish', 'draft', 'trash'].map(name => {
    const count = name === 'all' ? posts.filter(o => o.status !== 'trash').length : posts.filter(o => o.status === name).length;
    return /*#__PURE__*/_react.default.createElement(_antd.Tabs.TabPane, {
      key: name,
      tab: "".concat(name.toUpperCase(), " (").concat(count, ")")
    });
  }));

  const extra = [];

  if (taxonomies && taxonomies.length > 0) {
    extra.push( /*#__PURE__*/_react.default.createElement(_antd.Select, {
      key: "taxonomies",
      style: {
        width: 160
      },
      onChange: (v, o) => setCategory(o !== null && o !== void 0 && o.taxonomy ? {
        taxonomy: o.taxonomy,
        term: v
      } : ''),
      allowClear: true,
      placeholder: "Select category"
    }, taxonomies.map(o => {
      return /*#__PURE__*/_react.default.createElement(_antd.Select.OptGroup, {
        key: o.id,
        label: o.title
      }, o.terms && o.terms.map(p => {
        return /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
          key: p.id,
          value: p.id,
          taxonomy: o.id
        }, p.title);
      }));
    })));
  }

  extra.push( /*#__PURE__*/_react.default.createElement(_antd.Input.Search, {
    key: "search",
    allowClear: true,
    defaultValue: search,
    onChange: e => setSearch(e.target.value.toLowerCase())
  }));

  if (filter === 'trash') {
    extra.push( /*#__PURE__*/_react.default.createElement(_antd.Popconfirm, {
      key: "empty-trash",
      title: "Are you sure you want to empty the trash?",
      onConfirm: handleEmptyTrash,
      okText: "Yes",
      cancelText: "No",
      placement: "bottomRight",
      disabled: visiblePosts.length === 0
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      children: 'Empty trash',
      disabled: visiblePosts.length === 0,
      type: "danger"
    })));
  } else {
    extra.push( /*#__PURE__*/_react.default.createElement(_antd.Button, {
      key: "add",
      children: "Add",
      disabled: !postType,
      onClick: () => dispatch({
        type: 'SET_DIALOG',
        payload: {
          open: true,
          title: "Add ".concat(postType.title),
          component: /*#__PURE__*/_react.default.createElement(_PostForm.default, {
            onSubmit: handleAddPost,
            postTypeID: postTypeID
          })
        }
      }),
      type: "primary"
    }));
  }

  const renderPost = (o, level) => {
    var _sites$siteID4, _sites$siteID5, _o$locked;

    const slug = "/".concat((0, _utils.generateSlug)(postType, o.id, sites === null || sites === void 0 ? void 0 : (_sites$siteID4 = sites[siteID]) === null || _sites$siteID4 === void 0 ? void 0 : _sites$siteID4.frontPage));
    const actions = [];
    const isLocked = !!o.locked;

    const menu = /*#__PURE__*/_react.default.createElement(_antd.Menu, null, /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "duplicate",
      onClick: () => handleDuplicatePost({
        postID: o.id
      })
    }, "Duplicate"), o.status === 'trash' ? /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "delete",
      danger: true,
      onClick: () => handleDeletePost({
        postID: o.id
      }),
      disabled: isLocked
    }, "Delete") : /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "trash",
      danger: true,
      onClick: () => handleTrashPost({
        postID: o.id
      }),
      disabled: isLocked
    }, "Trash"));

    actions.unshift( /*#__PURE__*/_react.default.createElement(_antd.Dropdown.Button, {
      overlay: menu,
      trigger: ['click']
    }, /*#__PURE__*/_react.default.createElement(_router.Link, {
      to: slug
    }, isLocked ? 'View' : 'Edit')));
    let badges = [];

    if ((sites === null || sites === void 0 ? void 0 : (_sites$siteID5 = sites[siteID]) === null || _sites$siteID5 === void 0 ? void 0 : _sites$siteID5.frontPage) === o.id) {
      badges.push( /*#__PURE__*/_react.default.createElement(_Tag.default, {
        key: "front",
        children: 'front'
      }));
    }

    if (o.status === 'draft' || o.status === 'trash') {
      badges.push( /*#__PURE__*/_react.default.createElement(_Tag.default, {
        key: "status",
        children: o.status
      }));
    }

    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
      key: o.id
    }, /*#__PURE__*/_react.default.createElement(_ListItem.default, {
      level: level,
      actions: actions,
      title: o.title,
      subtitle: slug,
      status: badges,
      image: o.featuredImage,
      showImage: postTypeID !== 'page',
      link: slug,
      info: isLocked && "".concat((_o$locked = o.locked) === null || _o$locked === void 0 ? void 0 : _o$locked.email, " is currently editing")
    }), o.childNodes.map(p => renderPost(p, level + 1)));
  };

  const getListStyle = isDraggingOver => ({
    background: isDraggingOver ? _theme.colors.tertiary : 'transparent'
  });

  const getItemStyle = (isDragging, draggableStyle) => _objectSpread({
    userSelect: 'none',
    marginBottom: '8px'
  }, draggableStyle);

  const handleDragEnd = async result => {
    // dropped outside the list
    if (!result.destination) {
      return;
    }

    const index = result.source.index;
    const newIndex = result.destination.index;

    if (index === newIndex) {
      return;
    }

    const nextPosts = (0, _immer.default)(visiblePosts, draft => {
      if (newIndex > -1 && newIndex < draft.length) {
        const temp = draft[index];
        draft[index] = draft[newIndex];
        draft[newIndex] = temp;
        draft.map((o, i) => {
          return draft[i] = _objectSpread(_objectSpread({}, o), {}, {
            order: i
          });
        });
      }

      return draft;
    });
    await _actions.postActions.reorderPosts({
      siteID,
      postType,
      posts: nextPosts
    }, dispatch, config);
  };

  return /*#__PURE__*/_react.default.createElement(_CmsLayout.default, {
    pageTitle: (config === null || config === void 0 ? void 0 : (_config$fields2 = config.fields) === null || _config$fields2 === void 0 ? void 0 : (_config$fields2$postT = _config$fields2.postTypes) === null || _config$fields2$postT === void 0 ? void 0 : (_config$fields2$postT2 = _config$fields2$postT[postTypeID]) === null || _config$fields2$postT2 === void 0 ? void 0 : _config$fields2$postT2.title) || (postType === null || postType === void 0 ? void 0 : postType.title)
  }, /*#__PURE__*/_react.default.createElement(_antd.PageHeader, {
    title: filterItems,
    extra: extra
  }), !postType && /*#__PURE__*/_react.default.createElement(_antd.Alert, {
    message: "Unknown post type",
    description: "Restart the development process or sync new data now",
    type: "info",
    showIcon: true,
    action: /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "small",
      type: "ghost",
      onClick: handleSync,
      loading: isSyncing
    }, "Sync to WordPress")
  }), visiblePosts && /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 8
  }, filter === 'all' && postTypeID !== 'page' ? /*#__PURE__*/_react.default.createElement(_reactBeautifulDnd.DragDropContext, {
    onDragEnd: handleDragEnd
  }, /*#__PURE__*/_react.default.createElement(_reactBeautifulDnd.Droppable, {
    droppableId: "droppable"
  }, (provided, snapshot) => /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({}, provided.droppableProps, {
    ref: provided.innerRef,
    style: getListStyle(snapshot.isDraggingOver)
  }), visiblePosts.map((o, i) => {
    return /*#__PURE__*/_react.default.createElement(_reactBeautifulDnd.Draggable, {
      key: o.id,
      draggableId: "item-".concat(o.id),
      index: i
    }, (provided, snapshot) => /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
      ref: provided.innerRef
    }, provided.draggableProps, provided.dragHandleProps, {
      style: getItemStyle(snapshot.isDragging, provided.draggableProps.style)
    }), renderPost(o, 0)));
  }), provided.placeholder))) : visiblePosts.map(o => renderPost(o, 0))));
};

var _default = PostType;
exports.default = _default;