"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteCollection = exports.updateCollection = exports.addCollection = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _immer = _interopRequireDefault(require("immer"));

var _lodash = require("lodash");

var _ = require(".");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const addCollection = async (_ref, dispatch, config) => {
  let {
    siteID,
    id,
    title,
    slug
  } = _ref;
  let result = await (0, _.db)('createCollection', {
    siteID,
    id,
    title,
    slug
  }, dispatch, config);

  if (result) {
    result = transformCollection(result);
  }

  return result;
};

exports.addCollection = addCollection;

const updateCollection = async (_ref2, dispatch, config) => {
  let {
    siteID,
    id,
    title,
    slug
  } = _ref2;
  let result = await (0, _.db)('updateCollection', {
    id,
    siteID,
    title,
    slug
  }, dispatch, config);

  if (result) {
    result = transformCollection(result);
  }

  return result;
};

exports.updateCollection = updateCollection;

const deleteCollection = async (_ref3, dispatch, config) => {
  let {
    siteID,
    id
  } = _ref3;
  let result = await (0, _.db)('deleteCollection', {
    siteID,
    id
  }, dispatch, config);

  if (result) {
    result = transformCollection(result);
  }

  return result;
};

exports.deleteCollection = deleteCollection;

const transformCollection = collection => {
  const nextCollection = (0, _immer.default)(collection, draft => {
    if ((0, _lodash.get)(draft, "posts.items")) {
      draft.posts = draft.posts.items.reduce((ac, a) => _objectSpread(_objectSpread({}, ac), {}, {
        [a.id]: a
      }), {});
    }

    return draft;
  });
  return nextCollection;
};