"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMediaItems = exports.deleteMediaItem = exports.updateMediaItem = exports.addMediaItem = void 0;

var _antd = require("antd");

var _axios = _interopRequireDefault(require("axios"));

var _ = require(".");

var _utils = require("../utils");

var _actions = require("../actions");

// import app components
const addMediaItem = async (_ref, dispatch, config) => {
  let {
    siteID,
    file
  } = _ref;

  const user = _utils.auth.getUser(config);

  if (!(user !== null && user !== void 0 && user.authToken)) {
    _actions.authActions.signOut({}, dispatch, config);
  }

  try {
    const formData = new FormData();
    formData.append('file', file);
    const cleanedUrl = config === null || config === void 0 ? void 0 : config.source.replace(/\/+$/, '');
    let result = await _axios.default.post("".concat(cleanedUrl, "/wp-json/jamcms/v1/createMediaItem?siteID=").concat(siteID), formData, {
      headers: {
        'Content-Type': 'multipart/form-data',
        Authorization: "Bearer ".concat(user.authToken)
      }
    });
    const {
      data
    } = result;
    return data;
  } catch (err) {
    var _err$response, _err$response$data;

    if (err !== null && err !== void 0 && (_err$response = err.response) !== null && _err$response !== void 0 && (_err$response$data = _err$response.data) !== null && _err$response$data !== void 0 && _err$response$data.message) {
      _antd.message.error(err.response.data.message);
    }
  }
};

exports.addMediaItem = addMediaItem;

const updateMediaItem = async (_ref2, dispatch, config) => {
  let {
    siteID,
    id,
    altText
  } = _ref2;
  let result = await (0, _.db)('updateMediaItem', {
    siteID,
    id,
    altText
  }, dispatch, config);
  return result;
};

exports.updateMediaItem = updateMediaItem;

const deleteMediaItem = async (_ref3, dispatch, config) => {
  let {
    siteID,
    id
  } = _ref3;
  let result = await (0, _.db)('deleteMediaItem', {
    siteID,
    id
  }, dispatch, config);
  return result;
};

exports.deleteMediaItem = deleteMediaItem;

const getMediaItems = async (_ref4, dispatch, config) => {
  let {
    siteID,
    page,
    limit,
    search,
    allow
  } = _ref4;
  let result = await (0, _.db)('getMediaItems', {
    siteID,
    page,
    limit,
    search,
    allow
  }, dispatch, config);
  return result;
};

exports.getMediaItems = getMediaItems;