"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generatePreviewLink = exports.getPostPreview = exports.getSitePreview = void 0;

var _ = require(".");

var _utils = require("../utils");

const getSitePreview = async (_ref, dispatch, config) => {
  let {
    siteID,
    previewID
  } = _ref;
  let result = await (0, _.db)('getSitePreview', {
    siteID,
    previewID
  }, dispatch, config);

  if (result) {
    result = (0, _utils.formatSite)(result);
  }

  return result;
};

exports.getSitePreview = getSitePreview;

const getPostPreview = async (_ref2, dispatch, config) => {
  let {
    siteID,
    previewID
  } = _ref2;
  const result = await (0, _.db)('getPostPreview', {
    siteID,
    previewID
  }, dispatch, config);
  return result;
};

exports.getPostPreview = getPostPreview;

const generatePreviewLink = async (_ref3, dispatch, config) => {
  let {
    siteID,
    postID,
    expiryDate
  } = _ref3;
  const result = await (0, _.db)('getPreviewLink', {
    siteID,
    postID,
    expiryDate
  }, dispatch, config);
  return result;
};

exports.generatePreviewLink = generatePreviewLink;