"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _antd = require("antd");

var _axios = _interopRequireDefault(require("axios"));

var _htmlReactParser = _interopRequireDefault(require("html-react-parser"));

var _auth = require("../utils/auth");

var _actions = require("../actions");

// import app components
const db = async (endpoint, params, dispatch, config) => {
  const user = (0, _auth.getUser)(config);

  if (!(user !== null && user !== void 0 && user.authToken) && !(0, _auth.isPreview)()) {
    _actions.authActions.signOut({}, dispatch, config);
  }

  try {
    const formData = new FormData();
    Object.keys(params).map(key => typeof params[key] !== 'undefined' && formData.append(key, params[key])); // TODO: Move to utils function

    const cleanedUrl = config === null || config === void 0 ? void 0 : config.source.replace(/\/+$/, ''); // TODO: Make variable to allow for different CMS source

    const result = await _axios.default.post("".concat(cleanedUrl, "/wp-json/jamcms/v1/").concat(endpoint), formData, {
      headers: {
        'Content-Type': 'x-www-form-urlencoded',
        Authorization: "Bearer ".concat(user.authToken)
      }
    });
    return result === null || result === void 0 ? void 0 : result.data;
  } catch (err) {
    var _err$response, _err$response$data;

    if (err !== null && err !== void 0 && (_err$response = err.response) !== null && _err$response !== void 0 && (_err$response$data = _err$response.data) !== null && _err$response$data !== void 0 && _err$response$data.message) {
      if (endpoint === 'getAuthUser' || endpoint === 'getSite') {
        _actions.authActions.signOut({}, dispatch, config);
      } else {
        _antd.message.error((0, _htmlReactParser.default)(err.response.data.message));
      }
    }
  }
};

var _default = db;
exports.default = _default;